function input(){
	f=openRead(inFileName);
	K = readInt(f);
	lb=readInt(f);
	ub=readInt(f);
	r[1..K] = readInt(f);
	d[1..K] = readInt(f);
	beta[1..K] = readInt(f);
	nbPatterns=readInt(f);
	patterns[1..nbPatterns][1..K] = readInt(f);
	for[i in 1..nbPatterns]
		patternSize[i] = sum[k in 1..K](patterns[i][k]);	
	maxBatches=ceil((sum[i in 1..K](r[i])) / (0.0 + lb));
	println("nbVar:" + (maxBatches*nbPatterns));
}


function model(){
	x[1..nbPatterns][1..maxBatches] <- bool(); //x[i][j]=1 if pattern i goes in position j
	
	//at most one pattern on each slot
	for[j in 1..maxBatches]
		constraint sum[i in 1..nbPatterns](x[i][j]) <= 1;
	
	//meet the requests
	for[k in 1..K]
		constraint sum[i in 1..nbPatterns][j in 1..maxBatches](x[i][j] * patterns[i][k]) == r[k];

	for[j in 1..maxBatches]{
		size[j] <- sum[i in 1..nbPatterns](x[i][j] * patternSize[i]);
		
		for[k in 1..K]
			production[k][j] <- sum[i in 1..nbPatterns](x[i][j]*patterns[i][k]);
	}
	
	s[1] <- 0;
	c[1] <- size[1];
	for[j in 2..maxBatches]{
		s[j] <- c[j-1];
		c[j] <- s[j] + size[j];
	}
	
	//for[k in 1..K][j in 1..maxBatches]
	//	T[k][j] <- production[k][j] > 0 ? max(0,c[j] - d[k]) : 0;
	
	for[k in 1..K][j in 1..maxBatches]
		penalty[k][j] <- max(0,production[k][j]*(c[j] - d[k]));
	
	//minimize sum[k in 1..K][j in 1..maxBatches](T[k][j] * production[k][j]);
	minimize sum[k in 1..K][j in 1..maxBatches](penalty[k][j]);
}

function param(){
	if(lsTimeLimit==nil) lsTimeLimit=5;
}

function output(){
	for[k in 1..K]{
		print("customer " + k + ":\t");
		for[j in 1..maxBatches]{
			print(getValue(production[k][j]) + "\t");
		}
		println();
	}
	println();

	for[j in 1..maxBatches]{
		println("batch " + j + ":\t[" + getValue(s[j]) + "\t" + getValue(c[j]) + "]"); 
	}
}