function input(){
	f=openRead(inFileName);
	K = readInt(f);
	lb = readInt(f);
	ub = readInt(f);
	r[1..K] = readInt(f);
	d[1..K] = readInt(f);
	beta[1..K] = readInt(f);	
	totalDemand = sum[i in 1..K] (r[i]);
	maxBatches = ceil(totalDemand / (lb + 0.0)) ;	
	println(maxBatches*K);
}

function model(){
	x[1..K][1..maxBatches] <- bool();
	
	//each customer in one batch
	for[k in 1..K]
		constraint sum[b in 1..maxBatches] (x[k][b]) == 1;
	
	//size of each batch
	for[b in 1..maxBatches]
		size[b] <- sum[k in 1..K](x[k][b]*r[k]);
	
	//starting time of each batch
	s[1] <- 0;
	for[b in 2..maxBatches]
		s[b] <- s[b-1] + size[b-1];
		
	//ending time of each batch
	for[b in 1..maxBatches]
		c[b] <- s[b] + size[b];
		
	for[b in 1..maxBatches]{
		constraint size[b] > 0 ? lb <= size[b] : true;
		constraint size[b] <= ub;
	}
	
	for[k in 1..K]{
		completionTime[k] <- sum[b in 1..maxBatches](x[k][b]*c[b]);
		T[k] <- completionTime[k] > d[k] ? completionTime[k] - d[k] : 0;
	}
	
	minimize sum[k in 1..K](r[k] * beta[k] * T[k]);
	
}

function param(){
	if(lsTimeLimit==nil)
		lsTimeLimit=5;
}

function output(){
	/*for[k in 1..K]{
		print("customer " + k + "\t");
		for[b in 1..maxBatches]{
			print(getValue(x[k][b]) * r[k] + "\t");
		}
		println();
	}
	println();*/
	for[b in 1..maxBatches]{
		if(getValue(size[b]) > 0){
			print("batch " + b + ":\t" + getValue(s[b]) + "\t" + getValue(c[b]) + "\t");
			for[k in 1..K]{
				if(getValue(x[k][b]) > 0){
					print(k + ",");
				}
			}
		println();
		}
	}
}